//+------------------------------------------------------------------+
//|                                                       Martin.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//--- input parameters
extern int  Magic     = 777;
extern bool Trade      = false; /// 
extern int  TakeProfit = 50;
extern int  StopLoss   = 50;

int LastOrder; //       

double HMas_Ord_New[1000][7]; //   
double HMas_Ord_Old[1000][7];

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {
  double Lot, LastLot, profit; 
  if(OrdersTotal() == 0) //    ..  
   {
    HistoryOrders(); //    
    profit = HMas_Ord_New[LastOrder][6]; //    
    if(Trade == true && ((profit > 0) || (profit == 0))) //      ...
     {                              //   
      Send(OP_BUY,0.01,Ask,Ask - StopLoss*Point); //  
      return(0);
     }
    if((profit > 0) || (profit == 0)) return(0);
    //         
    LastLot = HMas_Ord_New[LastOrder][4]; //       
    //      :)
    if(LastLot == 0.01) Lot = 0.02; //      0.01..    0.02
    if(LastLot == 0.02) Lot = 0.04; //      0.02..    0.04
    if(LastLot == 0.04) Lot = 0.08;
    if(LastLot == 0.08) Lot = 0.16;
    if(LastLot == 0.16) Lot = 0.32;
    if(LastLot == 0.32) Lot = 0.64;
    if(LastLot == 0.64) Lot = 1.28;
    if(LastLot == 1.28) Lot = 2.56;
    if(LastLot == 2.56) Lot = 5.12;
    if(HMas_Ord_New[LastOrder][3] == 0) Send(OP_SELL,Lot,Bid,HMas_Ord_New[LastOrder][5]); //     ..  
    if(HMas_Ord_New[LastOrder][3] == 1) Send(OP_BUY,Lot,Ask,HMas_Ord_New[LastOrder][5]); //     ..  
   }
  return(0);
 }
//-------------------------------------------------------------------+
//                                             |
//-------------------------------------------------------------------+
int Send(int cmd, double lot, double price, double stoploss)
 {
  double takeprofit;
  if(cmd == OP_BUY) takeprofit = price + TakeProfit*Point;
  if(cmd == OP_SELL) takeprofit = price - TakeProfit*Point;
  // ,       " "  ...       
  if(Lock() == -1) return(0); //    ... 
  // ...    
  OrderSend(Symbol(),cmd,lot,price,3,stoploss,takeprofit,NULL,Magic,0,Green);
  UnLock(); // ...    
 }
//-------------------------------------------------------------------+
//  ... , ,    .       |
//-------------------------------------------------------------------+
int HistoryOrders()
 {
  int ticket;
  int Qnt = 0;                 //    //   
  LastOrder = 0;
  ArrayCopy(HMas_Ord_Old, HMas_Ord_New);  //   
  ArrayInitialize(HMas_Ord_New,0);        //  
  for(int i = 0; i < OrdersHistoryTotal(); i++)
   {
    Qnt++;
    if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) == false) continue;//  .
    if(Magic != OrderMagicNumber()) continue;
    if(Symbol() != OrderSymbol()) continue;               //..   .
    HMas_Ord_New[Qnt][1] = OrderMagicNumber();         //  
    HMas_Ord_New[Qnt][2] = OrderTicket();              //  
    HMas_Ord_New[Qnt][3] = OrderType();                //  
    HMas_Ord_New[Qnt][4] = OrderLots();                //  
    HMas_Ord_New[Qnt][5] = OrderOpenPrice();           //   
    HMas_Ord_New[Qnt][6] = OrderProfit();
    if(OrderTicket() > ticket)
     { //    
      ticket = OrderTicket();
      LastOrder = Qnt; //      
     }
   }
  HMas_Ord_New[0][0] = Qnt;                         // . 
  return(0);
 }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
int Lock()
 {
  bool CheckGV = false;
  CheckGV = GlobalVariableCheck("Semafor");//    
  if(CheckGV == false) // ,    Semafor
   {                                    //   ,
    if(GetLastError() != 0) return(-1);
     //  
    if(GlobalVariableSet("Semafor", -1.0) == 0) return(-1);//  
                                       //  
   }
  if(GlobalVariableGet("Semafor") == -1.0)
   { // " " ,  " "
    if(GlobalVariableSetOnCondition("Semafor", 1.0, -1.0)) return(1);//  "".  
     //  ,   " "
    Sleep(100);
   }
  return(-1);
 }
//+------------------------------------------------------------------+
//|                    |
//+------------------------------------------------------------------+
int UnLock()
 {
  bool CheckGV = false;
  CheckGV = GlobalVariableCheck("Semafor");//    
  if(CheckGV == false) // ,    Semafor
   { //   
    if(GetLastError() != 0) return(-1);
    if(GlobalVariableSet("Semafor", -1.0) == 0) return(-1);//  
       //  ,   return(-1);
   }
  while(!IsStopped()) //    -   
   { //  
    if(GlobalVariableSetOnCondition("Semafor", -1.0, 1.0)) return(-1);//  "".  
    Sleep(100); //   .  0.1 .   
   }
 }